//p1.java
//Tom Kratz

//Test example of using a form '
import java.util.StringTokenizer;
import java.util.Map;
import java.util.HashMap;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.FileReader;
import java.util.Scanner;
import java.awt.*;
import java.awt.event.* ;
import javax.swing.*;
import java.awt.FlowLayout;

@SuppressWarnings("serial")
/**
------------------------------------------------------------------------------
@Author Thomas Kratz
--File: SunInfo.java
--Project: Project 1
--Date: 24 September 2015
--Info: This program accesses the sunrise and sunset times of Kutztown from
--	the KutztownSunrise file.  Users may then select a month and day to see
--	the sunrise and set times of the selected day.
------------------------------------------------------------------------------
**/
public class SunInfo extends JFrame
{
	private static JComboBox<String> comboMonth;
	private static JComboBox<String> comboDay;
	private static HashMap <String, String> sunTimes=new HashMap<String, String>();
	private static JLabel SunriseLabel=new JLabel("Sunrise: ");
	private static JLabel SunsetLabel=new JLabel("Sunset: ");
	private JButton button = new JButton();
	
  public static void main(String[] args)
  {
	String[] Days = { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12",
		"13", "14", "15", "16", "17", "18", "19", "20", "21", "22",
		"23", "24", "25", "26", "27", "28", "29", "30", "31"};
	String[] Months = { "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" };	
	
	//=new HashMap<String, Integer>();
	sunTimes=processFile("KutztownSunrise",sunTimes);
	
	JFrame frame = new JFrame("Kutztown Solar Times");
	JPanel panel= new JPanel();
	panel.setLayout(new GridLayout(6, 1));
	JLabel titleLabel = new JLabel("Please select a date!");
	comboMonth = new JComboBox<String>(Months);
	comboDay = new JComboBox<String>(Days);

	
	JButton button = new JButton();
	button.setText("Look Up");
	panel.add(titleLabel);
	panel.add(comboMonth);
	panel.add(comboDay);	
	panel.add(button);
	panel.add(SunriseLabel);
	panel.add(SunsetLabel);
	
	MyListener listener= new MyListener(SunriseLabel, SunsetLabel);
	button.addActionListener(listener);
	
	frame.add(panel);
	frame.setSize(300, 300);
	frame.setLocationRelativeTo(null);
	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	frame.setVisible(true);

  }
  
/** CreateKey generates a key to be used to store a time in a hash map.
@param SROrSS	String delimiting sunrise or sunset entry.
@param month 	String identifying the month of the entry.
@param day	Integer identifying the day of the entry.
@return		String consisting of SROrSS+"-"+month+"-"+day.
*/
  public static String createKey(String SROrSS,  String month, int day){
	return SROrSS+"-"+month+"-"+day;
  
  }
  
/** lookupTime returns the requested sunrise or sunset time.
@param sunTimes	HashMap of the sunrise and sunset times
@param SROrSS	String delimiting sunrise or sunset entry.
@param month 	String identifying the month of the entry.
@param day	Integer identifying the day of the entry.
@return		String containing the time requested.
*/ 
  public static String lookupTime(HashMap<String, String> sunTimes, String SROrSS, String month, int day)
  {
	return ""+sunTimes.get(createKey(SROrSS,  month, day));
  }
 
/** CreateKey generates a key to be used to store a time in a hash map.
@param SROrSS	String delimiting sunrise or sunset entry.
@param month 	Integer identifying the month of the entry.
@param day	Integer identifying the day of the entry.
@return		String consisting of SROrSS+"-"+month+"-"+day.
*/ 
  public static String createKey(String SROrSS,  int month, int day){
	return SROrSS+"-"+intToStringMonth(month)+"-"+day;
  
  }
  
/** lookupTime returns the requested sunrise or sunset time.
@param sunTimes	HashMap of the sunrise and sunset times
@param SROrSS	String delimiting sunrise or sunset entry.
@param month 	Integer identifying the month of the entry.
@param day	Integer identifying the day of the entry.
@return		String containing the time requested.
*/ 
  public static String lookupTime(HashMap<String, String> sunTimes, String SROrSS, int month, int day)
  {
	return ""+sunTimes.get(createKey(SROrSS,  intToStringMonth(month), day));
  }
  
  /** intToStringMonth returns the string form of a numeric month
@param m 	Integer of month to be returned.
@return		String version of the month.
*/
  public static String intToStringMonth(int m)
  {
	if (m<2) return "January";
	if (m==2) return "February";
	if (m==3) return "March";
	if (m==4) return "April";
	if (m==5) return "May";
	if (m==6) return "June";
	if (m==7) return "July";
	if (m==8) return "August";
	if (m==9) return "September";
	if (m==10) return "October";
	if (m==11) return "November";
	return "December";
  }
/** processFile processes a standard sunrise and sunset time, inserting the time into a HashMap
@param sunTimes	HashMap of the sunrise and sunset times
@param file	String containing the file name to be proccessed.
@return		HashMap filled in with all sunrise and sunset times of that year.
*/ 
   public static HashMap<String, String> processFile(String file, HashMap<String, String> sunTimes)
  {
	try(BufferedReader br = new BufferedReader(new FileReader(file))) {
		StringTokenizer st = new StringTokenizer("blank");
		String nextTok= st.nextToken();
		String line;
		line = br.readLine();
		line = br.readLine();
		//int year=Integer.parseInt(line.split(" ")[37]);


		for (int i =0; i<=6;i++)
		{
			line = br.readLine();
		}
		for (int d=1; d<=31;d++){
			String nextLine=br.readLine();
			st=new StringTokenizer(nextLine);
			int skipFeb=0;
			int skipOthers=0;
			if (st.countTokens()<12*2+1) skipFeb=1;
			if (st.countTokens()==7*2+1) skipOthers=1;
			int dayCol=Integer.parseInt(st.nextToken());
			for (int m=1; m<=12; m++)
			{
				int SR=Integer.parseInt(st.nextToken());
				int SS=Integer.parseInt(st.nextToken());
				String srKey=createKey("SR", m, d);
				String ssKey=createKey("SS",  m, d);
				String SRS= ""+String.format("%02d", SR/100%12)+":"+String.format("%02d",SR%100)+" AM";
				String SSS= ""+String.format("%02d", SS/100%12)+":"+String.format("%02d",SS%100)+" PM";
				sunTimes.put(srKey, SRS);
				sunTimes.put(ssKey, SSS);
				//System.out.println(srKey+ " : " + SR);
				//System.out.println(ssKey+ " : " + SS);
				if (m==1) m=m+skipFeb;
				if (m==3 || m== 5 || m== 8 || m== 10) m+=skipOthers;
			}
		}
	}
	catch (Exception e){
         e.printStackTrace();
      }
      return sunTimes;
  }
  /** MyListener is the action listener used to update the form.
*/ 
  public static class MyListener implements ActionListener{
   
    private JLabel SRLabel;
    private JLabel SSLabel;
    
    public MyListener(JLabel label1, JLabel label2){
        SRLabel = label1;
	SSLabel = label2;
    }
    /** When activated, this function changes the display of two jframes to show the desired sunrise and sunset times.
*/ 
    public void actionPerformed(ActionEvent ae)  {
    try{
	String srTime="-";
	String ssTime="-";
        SRLabel.setText("Sunrise: "+ lookupTime(sunTimes, "SR", String.valueOf(comboMonth.getSelectedItem()), Integer.parseInt(String.valueOf(comboDay.getSelectedItem()))));
	SSLabel.setText("Sunset: "+ lookupTime(sunTimes, "SS", String.valueOf(comboMonth.getSelectedItem()), Integer.parseInt(String.valueOf(comboDay.getSelectedItem()))));
	}
	catch (Exception e){
         e.printStackTrace();
      }
    }

}



}